# --------------------------------------------------------------------------
# Check mandatories variable
- fail:
    msg: "Variable '{{ item }}' is not defined"
  when: item not in vars
  with_items:
    - api_token
    - job_name
    - project_id
    - dest

# --------------------------------------------------------------------------
# Get latest successful job in the given pipeline
- name: Retrieve latest succesful jobs
  become: true
  become_user: www-data
  get_url:
    url: "https://gitlab.com/api/v4/projects/{{ project_id }}/pipelines/{{ pipeline_id }}/jobs?scope=success"
    dest: "{{ dest }}/jobs.json"
    headers: "PRIVATE-TOKEN:{{ api_token }}"
  register: __job_file
  when: pipeline_id is defined and pipeline_id != ''
- name: Read job list JSON file
  shell: "cat {{ __job_file.dest }}"
  register: __job_content
  when: __job_file is defined and __job_file.dest is defined
- name: Delete JSON file
  become: true
  become_user: www-data
  file:
    path: "{{ dest }}/jobs.json"
    state: "absent"
- name: Set Job ID
  set_fact:
    __job_id: "{{__job_content.stdout | from_json | json_query(job_id_query)}}"
  vars:
    job_id_query: "[?name == '{{ job_name }}'] | [0].id"
  when: __job_file is defined and __job_file.dest is defined

# --------------------------------------------------------------------------
# Download the file from git_reference or job identifier
- name: Download artifact
  become: true
  become_user: www-data
  get_url:
    url: "{{ (__job_id is defined) | ternary(job_download, direct_download) }}"
    dest: "{{ dest }}/artifacts.zip"
    headers: "PRIVATE-TOKEN:{{ api_token }}"
    force: yes
  vars:
    direct_download: "https://gitlab.com/api/v4/projects/{{ project_id }}/jobs/artifacts/{{ git_reference | default('master') }}/download?job={{ job_name }}"
    job_download: "https://gitlab.com/api/v4/projects/{{ project_id }}/jobs/{{ __job_id | default('') }}/artifacts"
  register: __artifact_downloaded
- name: Unarchive artifact
  become: true
  become_user: www-data
  unarchive:
    src: "{{ dest}}/artifacts.zip"
    dest: "{{ dest }}"
    remote_src: true
  when: __artifact_downloaded|changed
- name: Delete artifact
  become: true
  become_user: www-data
  file:
    path: "{{ dest }}/artifacts.zip"
    state: "absent"
